<?php

$block_name = _("News delivery");

/**
 * This class extends Horde_Block:: to provide a list of deliverable internal
 * channels.
 *
 * $Horde: jonah/lib/Block/delivery.php,v 1.6 2005/08/24 05:39:13 selsky Exp $
 *
 * Copyright 2004-2005 Horde Project (http://horde.org/)
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://cvs.horde.org/co.php/jonah/LICENSE.
 *
 * @author  Roel Gloudemans <roel@gloudemans.info>
 * @package Horde_Block
 */
class Horde_Block_Jonah_delivery extends Horde_Block {

    var $_app = 'jonah';

    function Horde_Block_Jonah_delivery($params = array())
    {
        parent::Horde_Block($params);
        @define('JONAH_BASE', dirname(__FILE__) . '/../..');
        require_once JONAH_BASE . '/lib/Jonah.php';
        require_once JONAH_BASE . '/lib/News.php';
    }


    function _title()
    {
        return sprintf(_("Available Channels from %s"),
                       $GLOBALS['registry']->get('name', 'horde'));
    }

    function _content()
    {
        $news = &Jonah_News::singleton();

        $channels = array();
        $channels = $news->getChannels(JONAH_INTERNAL_CHANNEL);
        if (is_a($channels, 'PEAR_Error')) {
            $channels = array();
        }

        $html  = '<table border="0" cellpadding="1" cellspacing="0" width="100%"><tr>' .
                 '<tr><td colspan="2" class="control" nowrap="nowrap">' .
                 '<strong>' . _("Available News Channels") . '</strong></td></tr>';

        $style = 'item1';
        foreach ($channels as $key => $channel) {
            $style = $style == 'item0' ? 'item1' : 'item0';

            /* Link for HTML delivery. */
            $url = Horde::applicationUrl('delivery/html.php');
            $url = Util::addParameter($url, 'channel_id', $channel['channel_id']);
            $label = sprintf(_("\"%s\" stories in HTML"), $channel['channel_name']);
            $html .= '<tr class="' . $style . '"><td align="left" width="140">' .
                     Horde::img('story_marker.png') . ' ' .
                     Horde::link($url, $label, '', '', '', $label) .
                     $channel['channel_name'] . '</a></td>';

            /* Link for XML delivery. */
            $url = Horde::applicationUrl('delivery/rss.php', true, -1);
            $url = Util::addParameter($url, 'channel_id', $channel['channel_id']);
            $label = sprintf(_("\"%s\" stories in XML"), $channel['channel_name']);
            $html .= '<td align="right" nowrap="nowrap">' .
                     Horde::link($url, $label, '', '_blank', '', $label) .
                     Horde::img('xml.png') . '</a> ';

            /* Link for email delivery. */
            $url = Horde::applicationUrl('delivery/email.php');
            $url = Util::addParameter($url, 'channel_id', $channel['channel_id']);
            $label = sprintf(_("\"%s\" stories by email"), $channel['channel_name']);
            $html .= Horde::link($url, $label, '', '', '', $label) .
                Horde::img('email.png', $label) . 
                '</a></td></tr>';
        }

        $html .= '</table>';

        return $html;
    }

}
